<?php

	// Load gateway settings
	require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/idealcheckout/includes/library.php');
	$aDatabaseSettings = idealcheckout_getDatabaseSettings();





	global $wpdb, $wp_query, $wp_rewrite, $blog_id, $eshopoptions;
	$detailstable = $wpdb->prefix . 'eshop_orders';
	$derror = __('There appears to have been an error, please contact the site admin','eshop');

	// Sanitise
	include_once(WP_PLUGIN_DIR.'/eshop/cart-functions.php');
	$_POST = sanitise_array($_POST);

	$this_script = site_url();

	if(!isset($wp_query->query_vars['eshopaction']))
	{
		$eshopaction = 'process';
	}
	else
	{
		$eshopaction = $wp_query->query_vars['eshopaction'];
	}

	require_once(WP_PLUGIN_DIR . '/eshop/idealcheckoutsofortbanking/index.php');
	require_once(WP_PLUGIN_DIR . '/eshop/idealcheckoutsofortbanking/idealcheckoutsofortbanking.class.php');
	$oIdealcheckoutsofortbanking = new idealcheckoutsofortbanking_class();             // initiate an instance of the class


	if(strcmp($eshopaction, 'redirect') === 0)
	{
		$token = uniqid(md5($_SESSION['date' . $blog_id]), true);
		$checkid = md5($eshopoptions['business'] . $token . number_format($_SESSION['final_price' . $blog_id], 2));

		if(isset($_COOKIE['ap_id']))
		{
			$_POST['affiliate'] = $_COOKIE['ap_id'];
		}

		orderhandle($_POST, $checkid);
		

		if(isset($_COOKIE['ap_id']))
		{
			unset($_POST['affiliate']);
		}


		// Lookup order
		$sql = "SELECT * FROM `" . $wpdb->prefix . "eshop_orders` WHERE `checkid` = '" . idealcheckout_escapeSql($checkid) . "' LIMIT 1;";
		$aOrder = $wpdb->get_row($sql, ARRAY_A);

		// Update order status
		$sql = "UPDATE `" . $wpdb->prefix . "eshop_orders` SET `status` = 'Waiting' WHERE `checkid` = '" . idealcheckout_escapeSql($checkid) . "' LIMIT 1;";
		$wpdb->query($sql);

		// Lookup order total
		$sql = "SELECT SUM((`item_qty` * `item_amt`) + `tax_amt`) AS `order_total` FROM `" . $wpdb->prefix . "eshop_order_items` WHERE `checkid` = '" . idealcheckout_escapeSql($checkid) . "';";
		$aOrderTotal = $wpdb->get_row($sql, ARRAY_A);


		// Save order in database
		$sStoreCode = idealcheckout_getStoreCode();
		$sGatewayCode = 'sofortbanking';
		$sLanguageCode = 'nl'; // nl, de, en
		$sCountryCode = '';
		$sCurrencyCode = 'EUR';

		$sOrderId = $aOrder['id']; // idealcheckout_getRandomCode(16);
		$sOrderCode = idealcheckout_getRandomCode(32);
		$sTransactionId = idealcheckout_getRandomCode(32);
		$sTransactionCode = idealcheckout_getRandomCode(32);
		$fTransactionAmount = round($aOrderTotal['order_total'], 2);
		$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
		$sTransactionSuccessUrl = add_query_arg('eshopaction', 'success', get_permalink($eshopoptions['cart_success']));
		$sTransactionPendingUrl = $sTransactionSuccessUrl;
		$sTransactionFailureUrl = add_query_arg('eshopaction', 'cancel', get_permalink($eshopoptions['cart_cancel']));

		
		$aOrderParams = array('eshop_orders_checkid' => $checkid);


		// Setup automatic emails
		$aOrderParams['email_customer'] = array();
		$aOrderParams['email_customer']['send'] = false;
		$aOrderParams['email_customer']['to'] = '';
		$aOrderParams['email_customer']['subject'] = '';
		$aOrderParams['email_customer']['body'] = '';
		$aOrderParams['email_customer']['headers'] = '';



		// Load customer email (Uses template#100)
		include_once(WP_PLUGIN_DIR.'/eshop/cart-functions.php');
		$array = eshop_rtn_order_details($checkid);


		// Remove first line from $array['cart']
		// Because it says "Transaction id: Processing..."
		if(($iStrPos = strpos($array['cart'], "\n")) !== false)
		{
			$array['cart'] = trim(substr($array['cart'], $iStrPos));
		}


		$thisemail = $wpdb->get_row("SELECT `emailSubject`, `emailContent` FROM `" . $wpdb->prefix . "eshop_emails` WHERE ((`id` = '100' AND `emailUse` = '1') OR (`id` = '1')) ORDER BY `id` DESC LIMIT 1");
		$this_email = stripslashes($thisemail->emailContent);
		$csubject = stripslashes($thisemail->emailSubject);
		$this_email = eshop_email_parse($this_email, $array);
		$this_email = html_entity_decode($this_email, ENT_QUOTES);
		$headers = eshop_from_address();

		// Assign mail settings to params
		$aOrderParams['email_customer']['to'] = $array['eemail'];
		$aOrderParams['email_customer']['subject'] = $csubject;
		$aOrderParams['email_customer']['body'] = $this_email;
		$aOrderParams['email_customer']['headers'] = $headers;



		// Load webmaster email
		$aOrderParams['email_webmaster'] = array();
		$aOrderParams['email_webmaster']['to'] = ($eshopoptions['business'] ? $eshopoptions['business'] : $eshopoptions['from_email']);
		$aOrderParams['email_webmaster']['subject'] = false; // When FALSE, script uses "Transaction: ???, Status: ???"
		$aOrderParams['email_webmaster']['body'] = 'BETAALSTATUS UPDATE

Bestelling:     ' . $sOrderId . '
Bedrag:         ' . number_format($fTransactionAmount, 2, ',', '.') . '
Betaalmethode:  iDEAL Checkout - Sofort Banking
Transactie:     {TRANSACTION_ID}
Status:         {TRANSACTION_STATUS}

Klant:          ' . $array['eemail'] . '

Affiliate:      ' . ($array['affiliate'] ? $array['affiliate'] : '-') . '


Controleer de (eind)status van de betaling altijd via uw Payment Service Provider!';

		$aOrderParams['email_webmaster']['headers'] = eshop_from_address();




		$aOrderParams['customer'] = array();

		// Shipment data
		list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($aOrder['ship_address']);

		$aOrderParams['customer']['shipment_company'] = $aOrder['ship_company'];
		$aOrderParams['customer']['shipment_name'] = $aOrder['first_name'] . ' ' . $aOrder['last_name'];
		$aOrderParams['customer']['shipment_first_name'] = $aOrder['first_name'];
		$aOrderParams['customer']['shipment_last_name'] = $aOrder['last_name'];
		$aOrderParams['customer']['shipment_gender'] = '';
		$aOrderParams['customer']['shipment_date_of_birth'] = '';
		$aOrderParams['customer']['shipment_phone'] = $aOrder['ship_phone'];
		$aOrderParams['customer']['shipment_email'] = $aOrder['email'];
		$aOrderParams['customer']['shipment_address'] = $aOrder['ship_address'];
		$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
		$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
		$aOrderParams['customer']['shipment_street_number_extension'] = $sExtension;
		$aOrderParams['customer']['shipment_zipcode'] = $aOrder['ship_postcode'];
		$aOrderParams['customer']['shipment_city'] = $aOrder['ship_city'];
		$aOrderParams['customer']['shipment_country_code'] = $aOrder['ship_country'];
		$aOrderParams['customer']['shipment_country_name'] = ((strcasecmp($aOrderParams['customer']['shipment_country_code'], 'BE') === 0) ? 'Belgie' : 'Nederland');


		// Payment data
		list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($aOrder['address1'] . ' ' . $aOrder['address2']);

		$aOrderParams['customer']['payment_company'] = $aOrder['company'];
		$aOrderParams['customer']['payment_name'] = $aOrder['first_name'] . ' ' . $aOrder['last_name'];
		$aOrderParams['customer']['payment_first_name'] = $aOrder['first_name'];
		$aOrderParams['customer']['payment_last_name'] = $aOrder['last_name'];
		$aOrderParams['customer']['payment_gender'] = '';
		$aOrderParams['customer']['payment_date_of_birth'] = '';
		$aOrderParams['customer']['payment_phone'] = $aOrder['phone'];
		$aOrderParams['customer']['payment_email'] = $aOrder['email'];
		$aOrderParams['customer']['payment_address'] = $aOrder['address1'] . (empty($aOrder['address2']) ? '' : ', ' . $aOrder['address2']);
		$aOrderParams['customer']['payment_street_name'] = $sStreetName;
		$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
		$aOrderParams['customer']['payment_street_number_extension'] = $sExtension;
		$aOrderParams['customer']['payment_zipcode'] = $aOrder['zip'];
		$aOrderParams['customer']['payment_city'] = $aOrder['city'];
		$aOrderParams['customer']['payment_country_code'] = $aOrder['country'];
		$aOrderParams['customer']['payment_country_name'] = ((strcasecmp($aOrderParams['customer']['payment_country_code'], 'BE') === 0) ? 'Belgie' : 'Nederland');


		$aOrderParams['products'] = array();
		$aOrderParams['products'][] = array('code' => $sOrderId, 'description' => $sTransactionDescription, 'quantity' => 1, 'price_incl' => $fTransactionAmount, 'price_excl' => $fTransactionAmount, 'vat' => 0);



		// Insert into #_transactions
		$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

		$wpdb->query($sql);

		$sSiteRootUrl = site_url();

		if(substr($sSiteRootUrl, -1, 1) != '/')
		{
			$sSiteRootUrl .= '/';
		}

		header("Location: " . $sSiteRootUrl . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
		exit;
	}
	elseif(strcmp($eshopaction, 'process') === 0)
	{
		if(empty($eshopoptions['cart_success']) || empty($eshopoptions['cart_cancel']))
		{
			die('<p>' . $derror . '</p>');
		}

		$aHiddenFormFields = array();
		$aHiddenFormFields['shipping_1'] = number_format(isset($_SESSION['shipping'.$blog_id]['cost']) ? $_SESSION['shipping'.$blog_id]['cost'] : 0, 2);

		$sttable = $wpdb->prefix . 'eshop_states';
		$getstate = $eshopoptions['shipping_state'];
		
		if($eshopoptions['show_allstates'] != '1')
		{
			$stateList = $wpdb->get_results("SELECT id, code, stateName FROM " . $sttable . " WHERE (list = '" . $getstate . "') ORDER BY stateName", ARRAY_A);
		}
		else
		{
			$stateList = $wpdb->get_results("SELECT id, code, stateName, list FROM " . $sttable . " ORDER BY list, stateName", ARRAY_A);
		}

		foreach($stateList as $code => $value)
		{
			$eshopstatelist[$value['id']] = $value['code'];
		}

		foreach($_POST as $name => $value)
		{
			if(strstr($name, 'amount_'))
			{
				if(isset($_SESSION['eshop_discount' . $blog_id]) && eshop_discount_codes_check())
				{
					$chkcode=valid_eshop_discount_code($_SESSION['eshop_discount' . $blog_id]);

					if($chkcode && apply_eshop_discount_code('discount') > 0)
					{
						$discount = apply_eshop_discount_code('discount') / 100;
						$value = number_format(round($value-($value * $discount), 2), 2);
						$vset = 'yes';
					}
				}

				if(is_discountable(calculate_total())!=0 && !isset($vset))
				{
					$discount = is_discountable(calculate_total()) / 100;
					$value = number_format(round($value-($value * $discount), 2), 2);
				}
			}
			
			if(sizeof($stateList) > 0 && ($name == 'state' || $name == 'ship_state'))
			{
				if($value!='')
				{
					$value=$eshopstatelist[$value];
				}
			}

			$aHiddenFormFields[$name] = $value;
		}

		if('yes' == $eshopoptions['downloads_only'])
		{
			$aHiddenFormFields['no_shipping'] = '1';
		}
		
		if(($eshopoptions['status'] != 'live') && is_user_logged_in() && current_user_can('eShop_admin') || ($eshopoptions['status'] == 'live'))
		{
			$echoit .= '<form method="post" class="eshop" action="' . htmlspecialchars(add_query_arg('eshopaction', 'redirect', get_permalink($eshopoptions['checkout']))) . '"><div>';

			foreach($aHiddenFormFields as $name => $value)
			{
				$echoit .= '<input type="hidden" name="' . htmlspecialchars($name) . '" value="' . htmlspecialchars($value) . '" />';
			}

			$echoit .= '<input class="button submit2" type="submit" value="' . __('Proceed to Checkout &raquo;','eshop') . '" /></div></form>';
    	}
	}
	else
	{
		echo 'DEBUG: ' . __FILE__ . ' : ' . __LINE__ . ' : ' . $eshopaction . "<br>\n";
		exit;
	}

?>